#ifndef CONFLICTSRESTARTS_HPP_
#define CONFLICTSRESTARTS_HPP_
#define conflictsrestarts_hpp_version "$Revision: 1.1 $"

#include <stdint.h>
#include "Assertion.hpp"

class Conflicts2MaxLearnts{
	static const double 	addend = 3;
	double 					cls_count100;
	uint64_t 				conflicts;
	int64_t   				log2;
	uint64_t				max_learnts;
public:
	Conflicts2MaxLearnts():
		cls_count100(0),conflicts(0),log2(-1),max_learnts(0){}

	void setNumberClauses(double cls_count){
		cls_count100 = cls_count/100.0;
		max_learnts	 = (uint64_t)cls_count/3;
	}

	void incConflict(){
		++conflicts;
		if((conflicts & -conflicts) == conflicts){ //power of 2
			++log2; asrt(((uint64_t)1 << (uint32_t)log2) == conflicts);
			double add_inc 	= (double)(log2/144.0);
			uint64_t cand	= (uint64_t)((double)log2*(addend+add_inc)*cls_count100);
			max_learnts		= cand > max_learnts ? cand : max_learnts;

			//LOG_BASIC("Increment max_learnts to %llu at %%llu conflicts",max_learnts,conflicts);
		}

	}

	uint64_t getMaxLearnts()const 	{return max_learnts;}
	uint64_t getConflicts() const 	{return conflicts;}
};

class LubyRestarts{
	uint64_t factor;

	uint64_t restarts;
	uint64_t last_pow2;

	uint64_t incRestarts(){
			++restarts;
			if((restarts & -restarts) == restarts){ //power of 2
				last_pow2 = restarts;
				return restarts >> 1;
			}

			//find value
			uint64_t start 	= restarts;
			uint64_t l_pow2 = last_pow2;

			do{
				asrt(start > l_pow2); asrt(start < 2* l_pow2);
				start -= (l_pow2 - 1);
				while(l_pow2 > start){l_pow2 >>= 1;}

			}while(start != l_pow2);

			return start >> 1;
	}

public:
	LubyRestarts(uint64_t scale = 1):factor(scale),restarts(1),last_pow2(1){}

	void	setScale(uint64_t scale){factor = scale;}

	uint64_t nextRestartGetConflictCount(){	return incRestarts() * factor;}

	bool	isMinimumConflicts(uint64_t c){
			asrt(c >= factor);
			return c == factor;
	}


};




#endif /* CONFLICTSRESTARTS_HPP_ */
