/*
 * Globals.hpp
 *
 *  Created on: Sep 29, 2010
 *      Author: kottlers
 */

#ifndef GLOBALS_HPP_
#define GLOBALS_HPP_
#define globals_hpp_version "$Revision: 1.10 $"

#include "Settings.hpp"
#include "Satistics.hpp"
#include "MemPoolA.hpp"
#include "MemPoolP.hpp"
#include "BitVector.hpp"
#include "Random.hpp"
#include "WatchdCls.hpp"
#include "AssignInfos.hpp"
#include "Cemetery.hpp"

struct TGlobals{
	Settings			sets;
	Satistics 			stats;
	MemPoolP			c_info;
	char*				state_ok;
	Random				randy;
	Cemetery			cemetery;

	uint32_t			curr_long_lrnts;
	uint32_t			lbd_distri[Reason::LBD_MAX+1];

	Cls&		getCls(const ClsP& p) {
					return c_info.getRef<Cls>(p);}


	void			ensureVarVals(uint32_t sz){}

	bool 		setInvalid(const char* why){
					LOG1("Set invalid with reason " << std::string(why));
					if(state_ok==NULL){ state_ok = (char*)why;}
					return false;}

	bool 		isValid(){	return state_ok == NULL;}

	char* 		whyInvalid(){ asrt(state_ok!=NULL);
						return state_ok;}

	void		reValidate(){state_ok = NULL;}

	void 		registrLBD(const uint32_t& l){asrt(l<=Reason::LBD_MAX);
						++lbd_distri[l];++curr_long_lrnts;}

	/*void 		unregistrLBD(const uint32_t& l){asrt(l<=Reason::LBD_MAX); asrt(lbd_distri[l]>0);
					--lbd_distri[l]; --curr_long_lrnts;}*/

	void 		clearLBDDistri(){
					for(uint32_t i=Reason::LBD_MAX+1;i--;){lbd_distri[i]=0;}
					curr_long_lrnts = 0;}

	TGlobals():state_ok(NULL),curr_long_lrnts( 0){clearLBDDistri();}

	void		buryCls(const Literal& lit, Cls& cls, const int32_t lbd){
				cemetery.bury(lit,cls,lbd);}



	//inline ClsP clsCreate(Literal* lits, uint32_t sz,const uint32_t& lbd);


	/*inline void	clsFree(const ClsP& clp);
	inline void	silentFree(const Ptr32& clp, uint32_t mem_sz);
	inline void 	clsShrink(const ClsP& clp,const uint32_t keep, const uint32_t rem);
	inline void 	silentShrink(const ClsP& clp,const uint32_t shrnk);*/
};

/*

void TGlobals::silentFree(const Ptr32& clp, uint32_t mem_sz){
	c_info			.dealloc(clp,mem_sz);}

void TGlobals::silentShrink(const ClsP& clp,const uint32_t shrnk){
	Cls& cls		= getCls(clp); asrt(cls.unWatchdCnt()>shrnk);
	cls			.reduceUnWatchdCount(shrnk);
	asrt(c_info.validEndData(clp)); asrt(c_info.validEndData(clp+(cls.memSize()-1)));
	c_info		.dealloc(clp+cls.memSize(),shrnk);}
*/

/*
void TGlobals::clsFree(const ClsP& clp){
	Cls& cls		= getCls(clp);
	uint32_t mem	= cls.computeMem();
	stats.nbr_lits -= (mem+1); //asrt(!cls.flagged());
	stats.nbr_lcls--;
	c_info			.dealloc(clp,mem);}


void TGlobals::clsShrink(const ClsP& clp,const uint32_t keep, const uint32_t rem){ asrt(rem>0); asrt(keep>0);
	Cls& cls		= getCls(clp);
	ClsLit* lits	= cls.uwBeg();
	stats			.nbr_lits -= rem;
	lits[keep-1]	.has_next = 0;
	asrt(c_info.validEndData(clp)); asrt(c_info.validEndData(clp+keep));
	c_info			.dealloc(clp+keep+1,rem);}
*/






#endif /* GLOBALS_HPP_ */
