#ifndef ASSERTION_HPP_
#define ASSERTION_HPP_
#define assertion_hpp_version	  "$Revision: 1.1 $"

#include <execinfo.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <cassert>
#include <iostream>
#include <sys/resource.h>



inline void printStackTrace(){

	struct rusage ru;
	getrusage(RUSAGE_SELF, &ru);
	double sec = (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000.0;

	void *buffer[100];
	int nptrs 		= backtrace(buffer, 100);
	std::cerr << "Stack Trace after " << sec << " seconds. Stack depth is " << nptrs << std::endl;

    backtrace_symbols_fd(buffer+1, nptrs, STDERR_FILENO);
}



#ifdef NDEBUG
#define aux_var(x)
#define __ASRT(x,y) 	__ASSERT_VOID_CAST (0)

#if defined (ASRT_SWITCH)
#error "ASRT_SWITCH has no effect when NDEBUG is defined."
#endif

#if defined (SANITY_CHECKS)
#error "SANITY_CHECKS has no effect when NDEBUG is defined."
#endif



#else
#define aux_var(x)  x
#define __ASRT(x,str) \
  ((x) ? __ASSERT_VOID_CAST (0)		\
   : (printStackTrace(), __assert_fail (str, __FILE__, __LINE__, __ASSERT_FUNCTION), __ASSERT_VOID_CAST (0)))
#endif

#ifdef 	ASRT_SWITCH
extern bool asrt_ignore;
#define asrt(x) __ASRT(asrt_ignore || (x), __STRING(x) )
#define ASRT_ON asrt_ignore=false;
#define ASRT_OFF asrt_ignore=true;
#define ASRT_INIT bool asrt_ignore = false;
#else
#define asrt(x) __ASRT(x,__STRING(x))
#define ASRT_ON
#define ASRT_OFF
#define ASRT_INIT
#endif


#ifdef  SANITY_CHECKS
#define sanity(expr)	(asrt(expr))
#else
#define sanity(expr)	(__ASSERT_VOID_CAST (0))
#endif

//#undef	assert

#endif



/*inline void printStackTrac(std::ofstream& out){

	void *buffer[100];
	int nptrs 		= backtrace(buffer, 100);
   	out << "Call stack depth is " << nptrs << std::endl;

	char **strings 	= backtrace_symbols(buffer, nptrs);

	if (strings == NULL) {
    	out << "Call stack could not be printed" << std::endl;
        return;}

   for(int32_t j = 0; j < nptrs; ++j){
	   out << strings[j] << std::endl;}

   free(strings);
}*/
